## -*- texinfo -*-
## @deftypefn {Function File} {@var{p} =} inputParser ()
## Create an inputParser object.
## @end deftypefn

## Author: Ben Abbott <bpabbott@mac.com>
## Created: 2010-11-15

function parser = inputParser ()
  ## Initialize the structure.
  parser = struct ();

  ## Public Properties
  parser.Results = {};
  # Enabel/disable parameters case sensitivity.
  parser.CaseSensitive = false;
  # func name for error messages.
  x = dbstack ();
  if (numel (x) > 1)
    parser.FunctionName = x(2).name;
  else
    parser.FunctionName = "";
  endif
  # Enable/disable error for parmaters not defined by the constructor.
  parser.KeepUnmatched = false;
  # Enable/disable passing arguments in a structure.
  parser.StructExpand = true;
  # Names of parameters defined in inputParser constructor.
  parser.Parameters = {};
  # Names of parameters not defined in the constructor.
  parser.Unmatched = struct ();
  # Names of parameters using default values.
  parser.UsingDefaults = {};

  ## Handles for functions that act on the object.
  parser.addRequired = @addRequired;
  parser.addOptional = @addOptional;
  parser.addParamValue = @addParamValue;
  parser.createCopy = @createCopy;

  ## Specify the Public properties
  parser.public = fieldnames (parser);

  ## Private property
  parser.plan = {};

  ## Create an instance of the inputParser class.
  parser = class (parser, "inputParser");
endfunction

