## -*- texinfo -*-
## @deftypefn {Function File} {@var{v}} subsref (@var{p}, @var{f})
## Set a property of an inputParser object.
## @end deftypefn
function v = subsref (obj, prop)
  if (strcmp (prop(1).type, ".")
      && any (strcmp (prop(1).subs, fieldnames (obj))))
    v = builtin ("subsref", obj, prop);
  elseif (strcmp (prop(1).type, "()"))
    v = obj(prop.subs{:});
  elseif (! strcmp (prop(1).type, "."))
    error ("inputParser:invalidsubsref",
           "Invalid subsref for property of inputParser object.")
  else
    error ("inputParser:unknownerror")
  endif
endfunction


